
;	* * *   Screen update functions   * * *

(DEFUN UPDATE-SCRN (
    ROW ABOVE-POINT BELOW-POINT SCREEN )
  ( ((IDENTITY *STAT-WINDOW*))
    (CLEAR-STAT)
    (SPACES 4)
    (PRINC *FILE-NAME*)
    (SPACES (- (TRUNCATE *COLUMNS* 2) 8 (COLUMN)))
    (WRITE-STRING "  R:C")
    (SETQ *STAT-RC* (ADD1 (COLUMN)) *STAT-END* *STAT-RC* *STAT-WINDOW* T)
    (EDIT-WINDOW) )
  ((LISTEN))
  (IF (> *CURSOR-COL* *POINT-COL*) (SETQ *CURSOR-COL* *POINT-COL*))
  (IF (> *CURSOR-ROW* *POINT-ROW*) (SETQ *CURSOR-ROW* *POINT-ROW*))
  (SET-CURSOR *CURSOR-ROW* *CURSOR-COL*)
  (SETQ ABOVE-POINT *ABOVE-POINT*  BELOW-POINT *BELOW-POINT*)
  ( ((NOT *UNPACKED*)
      (UPDATE-AUX2 *CURSOR-ROW* BELOW-POINT)
      (POP BELOW-POINT) )
    (SETQ SCREEN (NTHCDR *CURSOR-ROW* *SCREEN*))
    (IF (ATOM (CAR SCREEN))
	(RPLACA SCREEN (NCONC (UNPACK (CAR SCREEN))
		(MAKE-LIST (- *COLUMNS* (LENGTH (CAR SCREEN))) *BLANK*))) )
    (SETQ SCREEN (CAR SCREEN))
    (UPDATE-AUX1 *CURSOR-COL* '+ *RIGHT-POINT*
		 (NTHCDR *CURSOR-COL* SCREEN))
    ((LISTEN)
      (RETURN) )
    (SETQ SCREEN (NREVERSE SCREEN))
    (UPDATE-AUX1 (SUB1 *CURSOR-COL*) '- *LEFT-POINT*
		 (NTHCDR (- *COLUMNS* *CURSOR-COL*) SCREEN))
    (NREVERSE SCREEN) )
  (SETQ ROW 0)
  (LOOP
    ((LISTEN))
    (INCQ ROW)
    ( ((>= (+ *CURSOR-ROW* ROW) *ROWS*))
      (UPDATE-AUX2 (+ *CURSOR-ROW* ROW) BELOW-POINT)
      (POP BELOW-POINT) )
    ( ((< *CURSOR-ROW* ROW))
      (UPDATE-AUX2 (- *CURSOR-ROW* ROW) ABOVE-POINT)
      (POP ABOVE-POINT) )
    ((AND (< *CURSOR-ROW* ROW) (>= (+ *CURSOR-ROW* ROW) *ROWS*))
      (UPDATE-STAT) ) ) )

(DEFUN UPDATE-AUX1 (COL +- TEXT-LINE LINE
    NUM )
  (LOOP
    ((NOT (SETQ NUM (MISMATCH LINE TEXT-LINE))))
    ((NULL (SETQ LINE (NTHCDR NUM LINE))))
    (SETQ TEXT-LINE (NTHCDR NUM TEXT-LINE))
    (INCQ COL (FUNCALL +- NUM))
    ((NULL TEXT-LINE)
      (LOOP
	((NULL (SETQ NUM (POSITION-IF 'NON-WHITESPACE LINE))))
	(SET-CURSOR *CURSOR-ROW* (INCQ COL (FUNCALL +- NUM)))
	(SETQ LINE (NTHCDR NUM LINE))
	(RPLACA LINE (WRITE-STRING *BLANK*))
	((LISTEN))
	(INCQ COL (FUNCALL +- 1))
	(POP LINE) ) )
    (SET-CURSOR *CURSOR-ROW* COL)
    (RPLACA LINE (WRITE-STRING (CAR TEXT-LINE)))
    ((LISTEN))
    (INCQ COL (FUNCALL +- 1))
    (POP LINE)
    (POP TEXT-LINE) ) )

(DEFUN UPDATE-AUX2 (ROW TEXT-LINE
    SCREEN )
  (SETQ SCREEN (NTHCDR ROW *SCREEN*))
  (IF (CONSP (CAR SCREEN))
      (RPLACA SCREEN (PACK (TRIM-LINE (CAR SCREEN)))))
  (SETQ TEXT-LINE (IF TEXT-LINE
		(SUBSTRING (CAR TEXT-LINE) (- *POINT-COL* *CURSOR-COL*)
			(+ (- *POINT-COL* *CURSOR-COL*) *COLUMNS* -1))
		*NUL-STRG*))
  ((EQ (CAR SCREEN) TEXT-LINE))
  (SET-CURSOR ROW 0)
  (SPACES (- (LENGTH (CAR SCREEN)) (LENGTH (WRITE-STRING TEXT-LINE))))
  (RPLACA SCREEN TEXT-LINE) )

(DEFUN UPDATE-STAT (
    )
  ( ((AND *STAT-INS* (EQ *STAT-ROW* *POINT-ROW*) (EQ *STAT-COL* *POINT-COL*))
      (SET-CURSOR *CURSOR-ROW* *CURSOR-COL*) )
    (STAT-WINDOW)
    ( ((IDENTITY *STAT-INS*))
      (SETQ *STAT-INS* T)
      (SET-CURSOR 0 (- *COLUMNS* 8))
      ((NOT *INSERT*)
	(WRITE-STRING "Replace") )
      (SETQ *HIGH-INTENSITY* T)
      (WRITE-STRING "Insert ")
      (SETQ *HIGH-INTENSITY*) )
    (SETQ *STAT-ROW* *POINT-ROW* *STAT-COL* *POINT-COL*)
    (SET-CURSOR 0 *STAT-RC*)
    (PRINC (ADD1 *STAT-ROW*))
    (WRITE-STRING '":")
    (PRINC (ADD1 *STAT-COL*))
    (SETQ *STAT-END* (PROG1 (COLUMN) (SPACES (- *STAT-END* (COLUMN)))))
    (EDIT-WINDOW) )

  ((NOT *BLINK-PAREN*))
  ((NOT *UNPACKED*)
    ((NULL *BELOW-POINT*))
    ((EQ (CHAR (CAR *BELOW-POINT*) *POINT-COL*) *LPAR*)
      (BLINK-RPAR (CAR *BELOW-POINT*) (CDR *BELOW-POINT*)) )
    ((EQ (CHAR (CAR *BELOW-POINT*) *POINT-COL*) *RPAR*)
      (BLINK-LPAR (CAR *BELOW-POINT*) *ABOVE-POINT*) ) )
  ((EQ (CAR *RIGHT-POINT*) *LPAR*)
    (BLINK-RPAR *RIGHT-POINT* *BELOW-POINT*) )
  ((EQ (CAR *RIGHT-POINT*) *RPAR*)
    (BLINK-LPAR *LEFT-POINT* *ABOVE-POINT*) ) )

(DEFUN BLINK-RPAR (LINE TEXT
    ROW COL NUM )
  (SETQ ROW *CURSOR-ROW*  COL *POINT-COL*  NUM 0)
  (LOOP
    ((LISTEN))
    (LOOP
      ((NULL (SETQ CHAR (IF (ATOM LINE) (CHAR LINE COL) (POP LINE)))))
      ( ((EQ CHAR *RPAR*)
	  (DECQ NUM) )
	((EQ CHAR *LPAR*)
	  (INCQ NUM) ) )
      ((ZEROP NUM))
      (INCQ COL) )
    ((ZEROP NUM)
      (BLINK-CHAR *RPAR*) )
    ((NULL TEXT))
    ((EQ (INCQ ROW) *ROWS*))
    (SETQ LINE (POP TEXT)
	  COL 0) ) )

(DEFUN BLINK-LPAR (LINE TEXT
    ROW COL NUM )
  (SETQ ROW *CURSOR-ROW*  COL *POINT-COL*  NUM 1)
  (LOOP
    (LOOP
      (DECQ COL)
      ((NULL (SETQ CHAR (IF (ATOM LINE) (CHAR LINE COL) (POP LINE)))))
      ( ((EQ CHAR *LPAR*)
	  (DECQ NUM) )
	((EQ CHAR *RPAR*)
	  (INCQ NUM) ) )
      ((ZEROP NUM)) )
    ((ZEROP NUM)
      (BLINK-CHAR *LPAR*) )
    ((LISTEN))
    ((MINUSP (DECQ ROW)))
    (SETQ LINE (POP TEXT)
	  COL (LENGTH LINE)) ) )
	
(DEFUN BLINK-CHAR (CHAR
    *BLINK* )
  (SETQ COL (- COL (- *POINT-COL* *CURSOR-COL*)))
  ((< -1 COL *COLUMNS*)
    (SETQ *BLINK* T)
    (SET-CURSOR ROW COL)
    (PRINC CHAR)
    (SET-CURSOR *CURSOR-ROW* *CURSOR-COL*)
    (LOOP
      ((LISTEN)) )
    (SETQ *BLINK*)
    (SET-CURSOR ROW COL)
    (PRINC CHAR) ) )

